/**
 * Copyright (C) 2013 Matteo Tamigi
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */
 
#include <iostream>
#include <conio.h>
using namespace std;

#include "pdfinfo.hpp"
#include "pdfworkspace.hpp"
#include "pdfcrack.hpp"

//Per la compilazione NON separata
#include "pdfinfo.cpp"
#include "pdfworkspace.cpp"
#include "pdfcrack.cpp"
#include "md5.cpp"
#include "rc4.cpp"

//Main di test per mostrare il funzionamento della libreria
int main () {
    PDFInfo pdf;
    PDFWorkspace ws;
    
    pdf.LoadPdfInfos("file.pdf");
    pdf.PrintInfos();
    if( pdf.GetErr() == 0 ) {
        pdf.initCracking();
        ws.SetWs(pdf.GetCrackWorkSpace(),       //Informazioni estratte dal file PDF
                 1,                             //Numero minimo di caratteri per il bruteforcing
                 4,                             //Numero massimo
                STD_CHARSET,                   //Charset da utilizzare
                USER);                         //USER = cerco la user_password
                                               //OWNER = cerco la owner_password 
        ws.run();
        if( ws.GetFound() )
            cout << "The password is: " << ws.GetPassword() << endl;
        else
            cout << "No password found!" << endl;
    } else {
        cout << "No valid file!" << endl;   
    }
    getch();
    return 0;
}
