/**
 * Copyright (C) 2013 Matteo Tamigi
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */


#ifndef PDFWORKSPACE_HPP
#define PDFWORKSPACE_HPP

#include "pdfcrack.hpp"
#include <string>
using namespace std;

//Questa classe prende in consegna le informazioni a monte (PDFInfo) e pianifica
//il cracking su più core della CPU in base ai thread disponibili.

// facilmente estendibile a pi core con l'utilizzo dei thread (da implementare
//in base all'architettura scelta!) in quanto chiama la classe PDFCrackVxRy che
//esegue il cracking vero e proprio: impostando un vettore di elementi PDFCrack
// possibile con un ciclo inviare pi esecuzioni simultanee (Vedi implementazione
//con le Qt di QPDFccpp)

class PDFWorkspace {
    public:
        //Funzioni pubbliche per la classe PDFSec (specificate in PDFSec.cpp)
        //Costruttori e distruttori
        PDFWorkspace ();
        PDFWorkspace ( EncWorkSpace , unsigned , unsigned , string , bool );
        ~PDFWorkspace ();
        //Funzioni SET e GET
        void SetWs ( EncWorkSpace , unsigned , unsigned , string , bool );
        void SetNextStatus ();
        //Funzioni per il debugging
        EncWorkSpace GetWs () { return encWs; }
        bool GetFound () { return found; }
        string GetPassword () { return pswd; }
        //Funzione di esecuzione del cracking
        void run ();
    private:
        EncWorkSpace encWs;
        PDFCrack * crack;
        int * stato;
        int lenStato;
        int lenCs;
        int max, min;
        bool ciclo;
        //Variabili dell'output
        string pswd;
        bool found;
};


#endif // PDFWORKSPACE_HPP
